--- app_voicemail.c     2004-10-20 13:29:34.000000000 -0400
+++ app_voicemail.new2  2004-10-20 13:26:29.000000000 -0400
@@ -436,29 +436,35 @@
        /* This function could be made to generate one from a database, too */
        struct ast_vm_user *vmu=NULL, *cur;
        ast_mutex_lock(&vmlock);
-       cur = users;
-       while (cur) {
-               if ((!context || !strcasecmp(context, cur->context)) &&
-                       (!strcasecmp(mailbox, cur->mailbox)))
-                               break;
-               cur=cur->next;
-       }
-       if (cur) {
-               if (ivm)
-                       vmu = ivm;
-               else
-                       /* Make a copy, so that on a reload, we have no race */
-                       vmu = malloc(sizeof(struct ast_vm_user));
-               if (vmu) {
-                       memcpy(vmu, cur, sizeof(struct ast_vm_user));
+        vmu = find_user_realtime(ivm,context,mailbox);
+        if (vmu) {
+               /* We're using a db! */
+        } else {
+               cur = users;
+               while (cur) {
+                       if ((!context || !strcasecmp(context, cur->context)) &&
+                               (!strcasecmp(mailbox, cur->mailbox)))
+                                       break;
+                       cur=cur->next;
+               }
+               if (cur) {
                        if (ivm)
-                               vmu->alloced = 0;
+                               vmu = ivm;
                        else
-                               vmu->alloced = 1;
-                       vmu->next = NULL;
+                               /* Make a copy, so that on a reload, we have no race */
+                               vmu = malloc(sizeof(struct ast_vm_user));
+                       if (vmu) {
+                               memcpy(vmu, cur, sizeof(struct ast_vm_user));
+                               if (ivm)
+                                       vmu->alloced = 0;
+                               else
+                                       vmu->alloced = 1;
+                               vmu->next = NULL;
+                       }
+               } else {
+                       vmu = find_user_realtime(ivm, context, mailbox);
                }
-       } else
-               vmu = find_user_realtime(ivm, context, mailbox);
+       }
        ast_mutex_unlock(&vmlock);
        return vmu;
 }